package com.migao.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.migao.config.response.BasePageRequest;
import com.migao.config.response.PageBeanOne;
import com.migao.config.response.ResponseBean;
import com.migao.entity.po.Company;
import com.migao.entity.po.DemandLibrary;
import com.migao.entity.po.Project;
import com.migao.entity.vo.req.DemandLibraryInsertReq;
import com.migao.entity.vo.req.DemandLibraryQueryReq;
import com.migao.entity.vo.req.DemandLibraryUpdateReq;
import com.migao.entity.vo.req.DemandSubProjectReq;
import com.migao.entity.vo.res.DemandLibraryPageQueryRes;
import com.migao.entity.vo.res.DemandLibraryQueryRes;
import com.migao.entity.vo.res.DictionaryListRes;

import java.util.List;

/**
 * @author dingsong
 */
public interface DemandLibraryService extends IService<DemandLibrary> {
    /**
     * 新增主需求
     * @param demandLibrary
     * @return
     */
    ResponseBean<?> insert(DemandLibraryInsertReq demandLibrary);

    /**
     * 新增子需求
     * @param demandSubProjectReq
     * @return
     */
    ResponseBean<?> insertSubProject(DemandSubProjectReq demandSubProjectReq);

    /**
     * 删
     * @param id
     * @return
     */
    ResponseBean<?> deleteById(String id);

    /**
     * 改
     * @param libraryUpdateReq
     * @return
     */
    ResponseBean<?> update(DemandLibraryUpdateReq libraryUpdateReq);

    /**
     * 分页查询所有需求数据
     * @param basePageRequest
     * @return
     */
    ResponseBean<PageBeanOne<DemandLibraryPageQueryRes>> pageQuery(BasePageRequest basePageRequest);

    /**
     * 分页查询当前用户需求数据
     * @param basePageRequest
     * @return
     */
    ResponseBean<PageBeanOne<DemandLibraryPageQueryRes>> pageQueryById(BasePageRequest basePageRequest);

    /**
     * 分页模糊查询所有需求数据
     * @param demandLibraryQuery
     * @return
     */
    ResponseBean<PageBeanOne<DemandLibraryPageQueryRes>> pageQueryOne(DemandLibraryQueryReq demandLibraryQuery);

    /**
     * 分页模糊查询当前用户需求数据
     * @param demandLibraryQuery
     * @return
     */
    ResponseBean<PageBeanOne<DemandLibraryPageQueryRes>> pageQueryOneById(DemandLibraryQueryReq demandLibraryQuery);

    /**
     * 通过id查询单条数据
     * @param id
     * @return
     */
    ResponseBean<DemandLibraryQueryRes> findById(String id);


    /**
     * 关联项目
     * @param key 关键字
     * @return
     */
    public ResponseBean<List<Project>> findProject(String key);

    /**
     * 需求分类下拉列表
     * @return
     */
    public ResponseBean<List<DictionaryListRes>> demandClassify();

    /**
     * 需求状态下拉列表
     * @return
     */
    public ResponseBean<List<DictionaryListRes>> demandState();

    /**
     * 需求单位下拉列表
     * @return
     */
    public ResponseBean<List<Company>> Company();
}
